use async_graphql::{
    async_stream::stream, futures_util::Stream, Context, Object, Subscription, ID,
};

pub struct SubscriptionRoot;

struct DownloadChanged {
    id: ID,
}

#[Object]
impl DownloadChanged {
    async fn id(&self) -> &ID {
        &self.id
    }
}

#[Subscription]
impl SubscriptionRoot {
    async fn get_download(&self, ctx: &Context<'_>) -> impl Stream<Item = DownloadChanged> {
        stream! {
            yield DownloadChanged {id: "Some-id".into()}
        }
    }
}
